/*
File: outtastockWidget.js
*/

var url="http://www.outtastock.com/summary.txt";			
var timerInterval=null;
var refresh=2000;
var last_updated = 0;
var xml_request = null;
var useGrowl = false;
var growlRegistered = null;
var runInBackGround = true;
var clickURL = "http://www.outtastock.com";


function load ()
{	
	if (window.widget)
	{
		// check if growl is running and register
		checkGrowl();
		
		widget.onshow = onshow;
		if (!runInBackGround) {
			widget.onhide = onhide;
		}
	}
}


function onshow() {
    if (timerInterval == null) {
        timerInterval = setInterval("show();", refresh);
    }
}

function onhide() {
    if (timerInterval != null) {
        clearInterval(timerInterval);
        timerInterval = null;
    }
}

function registerGrowl() {
	var obj = widget.system("/usr/bin/osascript scripts/RegisterGrowl.scpt", registerGrowlHandler);
}

function registerGrowlHandler(response) {
	var output = response.errorString;
	if (!output) {
		growlRegistered = true;
		//widget.setPreferenceForKey(true, "growlRegistered");
	}
}

function checkGrowl() {
	
    var obj = widget.system("/usr/bin/osascript scripts/CheckGrowl.scpt", checkGrowlHandler);
	
}

function checkGrowlHandler(response) {

	var output = response.outputString;
	if (output == "true\n") {
		useGrowl = true;
	} else {
		useGrowl = false;
	}
	
	if (useGrowl == true) {
		//growlRegistered = widget.preferenceForKey("growlRegistered");
		//if (!growlRegistered && growlRegistered != true) {
			registerGrowl();
		//}
	}
}


function growlAlert(message) {
	var obj = widget.system("/usr/bin/osascript scripts/GrowlAlert.scpt " + message.replace(/([^a-zA-Z0-9])/g, '\\$1'), null);
}

function growlAlertHandler(response) {
	return;
}

function show()
{
	var now = (new Date).getTime();
	
	// only check if 2.5 minutes have passed
	if ((now - last_updated) > 150000)
	{
		document.getElementById("stocktext").setAttribute("style","color:#3999c9;");
		document.getElementById("stocktext").innerText = "Pending Update";
		document.getElementById("helpertext").innerText = "";
		
		if (xml_request != null)
		{
			xml_request.abort();
			xml_request = null;
		}
		xml_request = new XMLHttpRequest();

		xml_request.onload = function(e) {summary_loaded(e, xml_request);}
		xml_request.open("GET", url);
		xml_request.setRequestHeader("Cache-Control", "no-cache");
		xml_request.send(null);
    }
}


function summary_loaded (e, request) 
{
	xml_request = null;
	if (request.responseText)
	{		
		var products = request.responseText.split(/\n/g);
		var product = products[3].split(",");
		
		link = document.getElementById("stocktext");
		//link.setAttribute("onclick","widget.openURL('"+product[1]+"')");
		clickURL = product[1];
		
		if (product[2] == 0)
		{
			link.setAttribute("style","color:#CCCCCC;");
			link.innerText = "No DS Available";
			document.getElementById("helpertext").innerText = "www.OuttaStock.com";
			
		}
		if (product[2] == 1)
		{
			link.setAttribute("style","color:#90DD00;");
			link.innerText = "DS in Stock!";
			document.getElementById("helpertext").innerText = "Click here now!";
			if (useGrowl && growlRegistered) {
				growlAlert("DS are in Stock!");
			}
		} 
				
		
		// set last_updated to the current time to keep track of the last time a request was posted
		last_updated = (new Date).getTime();
	}
}

function click ()
{
	if (widget)
	{
		widget.openURL(clickURL);
	}
}

